Skip to content
Start here

List Pools

client.LoadBalancers.Pools.List(ctx, params) (*SinglePage[Pool], error)
GET/accounts/{account_id}/load_balancers/pools

List configured pools.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Load Balancing: Monitors and Pools WriteLoad Balancing: Monitors and Pools Read
ParametersExpand Collapse
params PoolListParams
AccountID param.Field[string]

Path param: Identifier.

maxLength32
Monitor param.Field[string]optional

Query param: The ID of the Monitor to use for checking the health of origins within this pool.

ReturnsExpand Collapse
type Pool struct{…}
ID stringoptional
CheckRegions []CheckRegionoptional

A list of regions from which to run health checks. Null means every Cloudflare data center.

One of the following:
const CheckRegionWnam CheckRegion = "WNAM"
const CheckRegionEnam CheckRegion = "ENAM"
const CheckRegionWeu CheckRegion = "WEU"
const CheckRegionEeu CheckRegion = "EEU"
const CheckRegionNsam CheckRegion = "NSAM"
const CheckRegionSsam CheckRegion = "SSAM"
const CheckRegionOc CheckRegion = "OC"
const CheckRegionMe CheckRegion = "ME"
const CheckRegionNaf CheckRegion = "NAF"
const CheckRegionSaf CheckRegion = "SAF"
const CheckRegionSas CheckRegion = "SAS"
const CheckRegionSeas CheckRegion = "SEAS"
const CheckRegionNeas CheckRegion = "NEAS"
const CheckRegionAllRegions CheckRegion = "ALL_REGIONS"
CreatedOn stringoptional
Description stringoptional

A human-readable description of the pool.

DisabledAt Timeoptional

This field shows up only if the pool is disabled. This field is set with the time the pool was disabled at.

formatdate-time
Enabled booloptional

Whether to enable (the default) or disable this pool. Disabled pools will not receive traffic and are excluded from health checks. Disabling a pool will cause any load balancers using it to failover to the next pool (if any).

Latitude float64optional

The latitude of the data center containing the origins used in this pool in decimal degrees. If this is set, longitude must also be set.

LoadShedding LoadSheddingoptional

Configures load shedding policies and percentages for the pool.

DefaultPercent float64optional

The percent of traffic to shed from the pool, according to the default policy. Applies to new sessions and traffic without session affinity.

maximum100
minimum0
DefaultPolicy LoadSheddingDefaultPolicyoptional

The default policy to use when load shedding. A random policy randomly sheds a given percent of requests. A hash policy computes a hash over the CF-Connecting-IP address and sheds all requests originating from a percent of IPs.

One of the following:
const LoadSheddingDefaultPolicyRandom LoadSheddingDefaultPolicy = "random"
const LoadSheddingDefaultPolicyHash LoadSheddingDefaultPolicy = "hash"
SessionPercent float64optional

The percent of existing sessions to shed from the pool, according to the session policy.

maximum100
minimum0
SessionPolicy LoadSheddingSessionPolicyoptional

Only the hash policy is supported for existing sessions (to avoid exponential decay).

Longitude float64optional

The longitude of the data center containing the origins used in this pool in decimal degrees. If this is set, latitude must also be set.

MinimumOrigins int64optional

The minimum number of origins that must be healthy for this pool to serve traffic. If the number of healthy origins falls below this number, the pool will be marked unhealthy and will failover to the next available pool.

ModifiedOn stringoptional
Monitor stringoptional

The ID of the Monitor to use for checking the health of origins within this pool.

MonitorGroup stringoptional

The ID of the Monitor Group to use for checking the health of origins within this pool.

Name stringoptional

A short name (tag) for the pool. Only alphanumeric characters, hyphens, and underscores are allowed.

Networks []stringoptional

List of networks where Load Balancer or Pool is enabled.

NotificationEmail stringoptional

This field is now deprecated. It has been moved to Cloudflare's Centralized Notification service https://developers.cloudflare.com/fundamentals/notifications/. The email address to send health status notifications to. This can be an individual mailbox or a mailing list. Multiple emails can be supplied as a comma delimited list.

NotificationFilter NotificationFilteroptional

Filter pool and origin health notifications by resource type or health status. Use null to reset.

Origin FilterOptionsoptional

Filter options for a particular resource type (pool or origin). Use null to reset.

Disable booloptional

If set true, disable notifications for this type of resource (pool or origin).

Healthy booloptional

If present, send notifications only for this health status (e.g. false for only DOWN events). Use null to reset (all events).

Pool FilterOptionsoptional

Filter options for a particular resource type (pool or origin). Use null to reset.

Disable booloptional

If set true, disable notifications for this type of resource (pool or origin).

Healthy booloptional

If present, send notifications only for this health status (e.g. false for only DOWN events). Use null to reset (all events).

OriginSteering OriginSteeringoptional

Configures origin steering for the pool. Controls how origins are selected for new sessions and traffic without session affinity.

Policy OriginSteeringPolicyoptional

The type of origin steering policy to use.

  • "random": Select an origin randomly.
  • "hash": Select an origin by computing a hash over the CF-Connecting-IP address.
  • "least_outstanding_requests": Select an origin by taking into consideration origin weights, as well as each origin's number of outstanding requests. Origins with more pending requests are weighted proportionately less relative to others.
  • "least_connections": Select an origin by taking into consideration origin weights, as well as each origin's number of open connections. Origins with more open connections are weighted proportionately less relative to others. Supported for HTTP/1 and HTTP/2 connections.
One of the following:
const OriginSteeringPolicyRandom OriginSteeringPolicy = "random"
const OriginSteeringPolicyHash OriginSteeringPolicy = "hash"
const OriginSteeringPolicyLeastOutstandingRequests OriginSteeringPolicy = "least_outstanding_requests"
const OriginSteeringPolicyLeastConnections OriginSteeringPolicy = "least_connections"
Origins []Originoptional

The list of origins within this pool. Traffic directed at this pool is balanced across all currently healthy origins, provided the pool itself is healthy.

Address stringoptional

The IP address (IPv4 or IPv6) of the origin, or its publicly addressable hostname. Hostnames entered here should resolve directly to the origin, and not be a hostname proxied by Cloudflare. To set an internal/reserved address, virtual_network_id must also be set.

DisabledAt Timeoptional

This field shows up only if the origin is disabled. This field is set with the time the origin was disabled.

formatdate-time
Enabled booloptional

Whether to enable (the default) this origin within the pool. Disabled origins will not receive traffic and are excluded from health checks. The origin will only be disabled for the current pool.

Header Headeroptional

The request header is used to pass additional information with an HTTP request. Currently supported header is 'Host'.

Host []Hostoptional

The 'Host' header allows to override the hostname set in the HTTP request. Current support is 1 'Host' header override per origin.

Name stringoptional

A human-identifiable name for the origin.

Port int64optional

The port for upstream connections. A value of 0 means the default port for the protocol will be used.

VirtualNetworkID stringoptional

The virtual network subnet ID the origin belongs in. Virtual network must also belong to the account.

Weight float64optional

The weight of this origin relative to other origins in the pool. Based on the configured weight the total traffic is distributed among origins within the pool.

  • origin_steering.policy="least_outstanding_requests": Use weight to scale the origin's outstanding requests.
  • origin_steering.policy="least_connections": Use weight to scale the origin's open connections.
maximum1
minimum0
multipleOf0.01

List Pools

package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/load_balancers"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  page, err := client.LoadBalancers.Pools.List(context.TODO(), load_balancers.PoolListParams{
    AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", page)
}
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": [
    {
      "id": "17b5962d775c646f3f9725cbc7a53df4",
      "check_regions": [
        "WEU",
        "ENAM"
      ],
      "created_on": "2014-01-01T05:20:00.12345Z",
      "description": "Primary data center - Provider XYZ",
      "disabled_at": "2019-12-27T18:11:19.117Z",
      "enabled": false,
      "latitude": 0,
      "load_shedding": {
        "default_percent": 0,
        "default_policy": "random",
        "session_percent": 0,
        "session_policy": "hash"
      },
      "longitude": 0,
      "minimum_origins": 0,
      "modified_on": "2014-01-01T05:20:00.12345Z",
      "monitor": "monitor",
      "monitor_group": "monitor_group",
      "name": "primary-dc-1",
      "networks": [
        "string"
      ],
      "notification_email": "someone@example.com,sometwo@example.com",
      "notification_filter": {
        "origin": {
          "disable": true,
          "healthy": true
        },
        "pool": {
          "disable": true,
          "healthy": false
        }
      },
      "origin_steering": {
        "policy": "random"
      },
      "origins": [
        {
          "address": "0.0.0.0",
          "disabled_at": "2019-12-27T18:11:19.117Z",
          "enabled": true,
          "header": {
            "Host": [
              "example.com"
            ]
          },
          "name": "app-server-1",
          "port": 0,
          "virtual_network_id": "a5624d4e-044a-4ff0-b3e1-e2465353d4b4",
          "weight": 0.6
        }
      ]
    }
  ],
  "success": true,
  "result_info": {
    "count": 20,
    "page": 1,
    "per_page": 20,
    "total_count": 2000,
    "total_pages": 100
  }
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": [
    {
      "id": "17b5962d775c646f3f9725cbc7a53df4",
      "check_regions": [
        "WEU",
        "ENAM"
      ],
      "created_on": "2014-01-01T05:20:00.12345Z",
      "description": "Primary data center - Provider XYZ",
      "disabled_at": "2019-12-27T18:11:19.117Z",
      "enabled": false,
      "latitude": 0,
      "load_shedding": {
        "default_percent": 0,
        "default_policy": "random",
        "session_percent": 0,
        "session_policy": "hash"
      },
      "longitude": 0,
      "minimum_origins": 0,
      "modified_on": "2014-01-01T05:20:00.12345Z",
      "monitor": "monitor",
      "monitor_group": "monitor_group",
      "name": "primary-dc-1",
      "networks": [
        "string"
      ],
      "notification_email": "someone@example.com,sometwo@example.com",
      "notification_filter": {
        "origin": {
          "disable": true,
          "healthy": true
        },
        "pool": {
          "disable": true,
          "healthy": false
        }
      },
      "origin_steering": {
        "policy": "random"
      },
      "origins": [
        {
          "address": "0.0.0.0",
          "disabled_at": "2019-12-27T18:11:19.117Z",
          "enabled": true,
          "header": {
            "Host": [
              "example.com"
            ]
          },
          "name": "app-server-1",
          "port": 0,
          "virtual_network_id": "a5624d4e-044a-4ff0-b3e1-e2465353d4b4",
          "weight": 0.6
        }
      ]
    }
  ],
  "success": true,
  "result_info": {
    "count": 20,
    "page": 1,
    "per_page": 20,
    "total_count": 2000,
    "total_pages": 100
  }
}